#ifndef MSP_DEMOSCENE_ANIMATE_H_
#define MSP_DEMOSCENE_ANIMATE_H_

#include <msp/gl/animation.h>
#include <msp/gl/animationplayer.h>
#include "action.h"

class Animate: public Action
{
public:
	class Loader: public Msp::DataFile::DerivedObjectLoader<Animate, Action::Loader>
	{
	public:
		Loader(Animate &, Demo &);

	private:
		void animation(const std::string &);
		void target(const std::string &);
	};

private:
	Msp::GL::Placeable *target;
	const Msp::GL::Animation *anim;
	Msp::GL::AnimationPlayer *player;

public:
	Animate();
	Animate(Msp::GL::Placeable &, const Msp::GL::Animation &, Msp::GL::AnimationPlayer &);

	virtual void validate() const;

	virtual void start(float, float);
};

#endif
