#include <msp/strings/format.h>
#include "beatcounter.h"

using namespace Msp;

BeatCounter::BeatCounter(Resources &resources):
	text(resources.get_ui_font(), &resources.get_ui_text_technique()),
	instance(text)
{
	text.set_alignment(GL::Text::CENTER);
	instance.set_matrix(GL::Matrix::scaling(0.02f));
}

void BeatCounter::beat(int b)
{
	text.set_text(format("%d / %d", b/4, b%4));
}

void BeatCounter::render(GL::Renderer &renderer, const GL::Tag &tag) const
{
	instance.render(renderer, tag);
}
